var express = require('express');
var http = require('http');
var io = require('socket.io');
var bodyParser = require('body-parser');
var cookieParser = require('cookie-parser');
 
var app = express();

app.use(express.static('./public'));
//Specifying the public folder of the server to make the html accesible using the static middleware
app.use(cookieParser());

var jsonParser = bodyParser.json()
 
// create application/x-www-form-urlencoded parser 
var urlencodedParser = bodyParser.urlencoded({ extended: false })
 
// POST /login gets urlencoded bodies 



function findSocketByCookie(cookie) {
  for(var i in io.sockets.connected) {
    var socket = io.sockets.connected[i];
    if(socket.handshake.headers.cookie.indexOf(cookie) !== -1){
      return socket;
    }
  }
}

app.post('/show', urlencodedParser, function (req, res) {
  var socket = findSocketByCookie(req.cookies.myUniqueCookie);
  res.sendStatus(200);
  console.log("Sending json to live interface");
  socket.emit("jsonHoneycomb", req.body.honeyComb);
});

var server = http.createServer(app).listen(8080);

console.log("Listening on port 8080");
console.log("Send jsons to /show please.")
//Server listens on the port 8124
var io = io.listen(server); 
/*initializing the websockets communication , server instance has to be sent as the argument */
io.sockets.on('connection', function(socket){

	console.log("New Client Connected.");

    socket.on('disconnect', function () {
      console.log("Client disconnected.")
    });

    socket.on('ackMessage', function(msg){
      if(msg == "true"){
        console.log('Message received.');
      }
  });
});
